HDU 3001-Travelling(三进制状压DP)

Travelling

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 7902    Accepted Submission(s): 2585


Problem Description
After coding so many days,Mr Acmer wants to have a good rest.So travelling is the best choice!He has decided to visit n cities(he insists on seeing all the cities!And he does not mind which city being his start station because superman can bring him to any city at first but only once.), and of course there are m roads here,following a fee as usual.But Mr Acmer gets bored so easily that he doesn't want to visit a city more than twice!And he is so mean that he wants to minimize the total fee!He is lazy you see.So he turns to you for help.
 

Input
There are several test cases,the first line is two intergers n(1<=n<=10) and m,which means he needs to visit n cities and there are m roads he can choose,then m lines follow,each line will include three intergers a,b and c(1<=a,b<=n),means there is a road between a and b and the cost is of course c.Input to the End Of File.
 

Output
Output the minimum fee that he should pay,or -1 if he can't find such a route.
 

Sample Input
  
  
2 1 1 2 100 3 2 1 2 40 2 3 50 3 3 1 2 3 1 3 4 2 3 10
 

Sample Output
  
  
100 90 7
 

Source
 

Recommend
gaojie   |   We have carefully selected several similar problems for you:   3004  3002  3006  3007  3003 

题意:n个点,m条边,让你从某一个点到其他所有点的花费之和最小,并且一个城市最多不能经过超过两次。
题解:本来觉得是个不能再水的题了,跑一发floyd然后求波最小值??后来发现是自己瞎了,每个城市经过次数
有限制,这该怎么搞?可以想想假如没有规定次数呢?
假如没有规定次数的话,就很明确,首先跑一发floyd求出任意两点的最短路,然后二进制枚举最后一个点是哪个。。
这是很好想的,但其实你想到这里的话问题其实就能够解决了,因为这题也是相似的,仅有的不同是一个城市的状态就不再是0和1了,而是0、1、2三种状态,咦~~这不是三进制吗,没错就是三进制,呢就又将问题转化为状态压缩问题了,还是状压DP搞搞啊,三进制怎么办?开个数组模拟一下就好啦。。。
首先预处理出两个数组a和num
a[i]:枚举3的i次方
num[i][j]:表示状态(三进制)为i时第j位是多少
然后状压时用dp[i][j]:状态为i且以j为终点时的最小花费。。。

#include<map>      
#include<stack>      
#include<queue>      
#include<vector>      
#include<math.h>      
#include<stdio.h>      
#include<iostream>      
#include<string.h>      
#include<stdlib.h>      
#include<algorithm>      
using namespace std;      
typedef long long  ll;      
#define inf 1000000000     
#define mod 100000000       
#define  maxn  1<<15    
#define  lowbit(x) (x&-x)      
#define  eps 1e-10  
int dp[60050][15],num[60060][15],a[15],d[15][15];
void init()
{
	int i,j;a[0]=1;
	for(i=1;i<=10;i++)
		a[i]=a[i-1]*3;
	for(i=0;i<a[10];i++)
	{
		int tmp=i;
		for(j=0;j<10;j++)
		{
			num[i][j]=tmp%3;
			tmp/=3;
		}
	}
}
int  main(void)
{
	init();
	int n,m,i,j,k,x,y,z;
	while(scanf("%d%d",&n,&m)!=EOF)
	{
		int ans=inf;
		memset(d,127,sizeof(d));
		for(i=1;i<=m;i++)
		{
			scanf("%d%d%d",&x,&y,&z);
			x--;y--;
			d[x][y]=d[y][x]=min(d[x][y],z);
		}
		for(i=0;i<a[n];i++)
			for(j=0;j<10;j++)
				dp[i][j]=inf;
		for(i=0;i<n;i++)
			dp[a[i]][i]=0;
		for(i=0;i<a[n];i++)
		{
			bool mark=0;
			for(j=0;j<n;j++)
			{
				if(num[i][j]==0)
					mark=1;
				if(dp[i][j]==inf)
					continue;
				for(k=0;k<n;k++)
				{
					if(d[j][k]==inf || num[i][k]==2)
						continue;
					int tmp=i+a[k];
					dp[tmp][k]=min(dp[tmp][k],dp[i][j]+d[j][k]);
				}
			}
			if(mark==0)
				for(j=0;j<n;j++)
					ans=min(ans,dp[i][j]);
		}
		if(ans==inf)
			ans=-1;
		printf("%d\n",ans);
	}
	return 0;
}


  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值